
import types
import renderPageTemplate

indent = u'  '

class XMLMixin:
        def XMLRepresentation(self, tagName, XO, level=0):
                ListsDic = {}
                AttrsDic = {}
                ElementsDic = {}
                result = level * indent + u'<%s' % tagName
                for attr, attrValue in XO.__dict__.items():
##                        print attr, attrValue, type(attrValue)
                        if type(attrValue) == type([]):
##                                print 'list'
                                ListsDic[attr] = attrValue
                        elif type(attrValue) == type(u''):
##                                print 'attr'
                                AttrsDic[attr] = attrValue
                        else:
##                                print 'elem'
                                ElementsDic[attr] = attrValue
                for attr, attrValue in AttrsDic.items():
                        if attr <> 'PCDATA':
                                result = result + ' %s="%s"' % (attr, attrValue)
                if (not ListsDic) and (not ElementsDic) and not hasattr(XO, 'PCDATA'):
                        return result + '/>'
                else:
                        result = result + '>'
                        if hasattr(XO, 'PCDATA'):
                                result = result + XO.PCDATA
                        for attr, attrValue in ElementsDic.items():
                                result = result + '\n' + level * indent + self.XMLRepresentation(attr, attrValue, level + 1)
                        for attr, attrValue in ListsDic.items():
                                for elem in attrValue:
                                        result = result + '\n' + level * indent + self.XMLRepresentation(attr, elem, level + 1)
                        if ElementsDic.items() or ListsDic.items():
                                result = result + '\n' + level * indent
                        return result + '</%s>' % tagName

class TableMixin(XMLMixin):
        PRIMARYKEY_ATTRIBUTE_NAME = 'primarykey'
        TRACING_ATTRIBUTE_NAME = 'tracing'
        UNIQUEFIELD_ATTRIBUTE_NAME = 'unique'
        GENERATORFIELD_ATTRIBUTE_NAME = 'generator'

        def primarykeys(self):
                result = []
                for field in self.field:
                        if hasattr(field, self.PRIMARYKEY_ATTRIBUTE_NAME):
                                renderPageTemplate.addBaseClass(field, fieldMixin)
                                result.append(field)
                return result

        def getFields(self):
                result = []
                if hasattr(self, 'field'):
                        if type(self.field) is types.ListType:
                                for field in self.field:
                                        renderPageTemplate.addBaseClass(field, fieldMixin)
                                        result.append(field)
                        else:
                                renderPageTemplate.addBaseClass(self.field, fieldMixin)
                                result.append(self.field)
                return result

        def uniqueFields(self):
                result = []
                for field in self.getFields():
                        if hasattr(field, self.UNIQUEFIELD_ATTRIBUTE_NAME):
                                result.append(field)
                return result
        
        def noPrimarykeys(self):
                result = []
                for field in self.getFields():
                        if not(hasattr(field, self.PRIMARYKEY_ATTRIBUTE_NAME)):
                                result.append(field)
                return result
        
        def tracingFields(self):            
                result = []
                for field in self.getFields():
                        if hasattr(field, self.TRACING_ATTRIBUTE_NAME):
                                result.append(field)
                return result

        def tracingExcludedFields(self):            
                result = []
                for field in self.getFields():
                        if not (field in self.tracingFields()):
                                result.append(field)
                return result

        def noGeneratorFields(self):
                result = []
                for field in self.getFields():
                        if not(hasattr(field, self.GENERATORFIELD_ATTRIBUTE_NAME)):
                                result.append(field)
                return result

        def updateableFields(self):
                result = []
                for field in self.getFields():
                        if (field in self.tracingExcludedFields()) \
                                and (field in self.noGeneratorFields()):
                                result.append(field)
                return result

        def likeFields(self):
                result = []
                for field in self.tracingExcludedFields():
                        if (field.convertSQLTypeToDTMLSQLType() in ['string', 'float', 'int']):
                                renderPageTemplate.addBaseClass(field, fieldMixin)
                                result.append(field)
                        if field.type == 'TIMESTAMP':
                                renderPageTemplate.addBaseClass(field, fieldMixin)
                                result.append(field)
                return result

        def getDisplayLabel(self):
                result = ''
                display = self._getDisplay()
                if display and hasattr(display, 'label'):
                        result = display.label.PCDATA.encode('latin-1')
                return result

        def getDisplayDescription(self):
                result = ''
                display = self._getDisplay()
                if display and hasattr(display, 'description'):
                        result = display.description.PCDATA.encode('latin-1')
                return result

        def _getDisplay(self):
                result = None
                if hasattr(self, 'display'):
                    result = self.display
                return result

        def getName(self):
                return self.name.encode('ascii')

class fieldMixin:
        def _getDisplay(self):
                result = None
                if hasattr(self, 'display'):
                     result = self.display
                return result

        def getDisplayLabel(self):
                result = ''
                display = self._getDisplay()
                if display and hasattr(display, 'label'):
                     result = display.label.encode('latin-1')
                return result

        def getDisplayVisible(self):
                result = 0
                display = self._getDisplay()
                if display and hasattr(display, 'visible'):
                        result = 1
                return result

        def getName(self):
                return self.name.encode('ascii')

        def getType(self):
                return self.type.encode('ascii')

        def getBrowseDisplayType(self):
                if self.getLookup() and self.getLookup().display:
                        return 'lookup'
                type = self.getType()
                if type == 'TIMESTAMP':
                        return 'timestamp'
                if type == 'CHAR':
                        return 'string'
                if type == 'VARCHAR':
                        return 'string'
                if type == 'INTEGER':
                        return 'int'
                if type == 'DECIMAL':
                        return 'float'
                if type == 'FLOAT':
                        return 'float'

        def getSearchSqlTest(self):
                 dic = {}
                 dic['fieldName'] = self.getName()
                 result = '''
<dtml-if "%(fieldName)s == '%%'">
        ((%(fieldName)s like '%%') or (%(fieldName)s IS NULL))
<dtml-else>
        (%(fieldName)s like '<dtml-var %(fieldName)s>')
</dtml-if>
'''               
                 return result % dic

        def getLookup(self):
                if hasattr(self, 'lookup'):
                        return self.lookup
                if hasattr(self, 'foreignkey'):
                        self.lookup = Lookup(self.foreignkey)
                else:
                        self.lookup = None
                return self.lookup
        
        def getFieldPropertyMap(self):
                result = {}
                result['type']=('type', self.getBrowseDisplayType(), 'string')
                lookup = self.getLookup()
                if lookup:
                        result['lookupTable']= ('lookupTable', lookup.tableName, 'string')
                        result['lookupResultField']= ('lookupResultField', lookup.resultFieldName, 'string')
                        result['lookupCodeField']= ('lookupCodeField', lookup.codeFieldName, 'string')
                return result

        def convertSQLTypeToDTMLSQLType(self):
                if not hasattr(self, 'SQLMap'):
                        self.SQLMap = {}
                        self.SQLMap['CHAR'] = 'string'
                        self.SQLMap['VARCHAR'] = 'string'
                        self.SQLMap['DATE'] = 'nb'
                        self.SQLMap['TIMESTAMP'] = 'nb'
                        self.SQLMap['DECIMAL'] = 'float'
                        self.SQLMap['FLOAT'] = 'float'
                        self.SQLMap['INTEGER'] = 'int'
                return self.SQLMap[self.type]

        def getZSQLDTMLForFieldValueWithParam(self, paramName):
                if self.type == 'TIMESTAMP':
                        return "'<dtml-var %s fmt=ISO>'" % paramName
                else:
                        return '<dtml-sqlvar %s type=%s>' % (paramName, self.convertSQLTypeToDTMLSQLType())

        def getZSQLDTMLForFieldValue(self):
                return self.getZSQLDTMLForFieldValueWithParam(self.name.encode('ascii'))

                
class Lookup:
        def __init__(self, cfgForeignKey):
                self.display = hasattr(cfgForeignKey, 'display')
                try:
                        self.tableName = cfgForeignKey.display.table.name.encode('ascii').lower()
                except AttributeError:
                        self.tableName = cfgForeignKey.table.name.encode('ascii').lower()
                try:
                        self.resultFieldName = cfgForeignKey.display.field.name.encode('ascii').upper()
                except AttributeError:
                        self.resultFieldName = cfgForeignKey.field.name.encode('ascii').upper()
                self.codeFieldName = cfgForeignKey.field.name.encode('ascii').upper()
                try:
                        self.filterFieldValue = cfgForeignKey.display.filter.field.value
                except:
                        self.filterFieldValue = ""
                try:
                        self.filterFieldName = cfgForeignKey.display.filter.field.name
                except:
                        self.filterFieldName = ""
