from PageTemplates.PageTemplate import PageTemplate
from gnosis.xml.objectify import XML_Objectify

import os

class renderPageTemplate:
        pt_cache = {}
        
        def __init__(self):
                self.pt = None
                self.context = {}
                
        def setTemplateFromFile(self, templateFileName, id='main'):
                templateString = open(templateFileName).read()
                if self.setTemplateFromString(templateString):
                        print 'page template %s added' % os.path.abspath(templateFileName)

        def setTemplateFromString(self, templateString, id='main'):
                cacheKey = '%s_%s' % (id, templateString)
                if self.pt_cache.has_key(cacheKey):
                        self.pt = self.pt_cache[cacheKey]
                        return 0
                else:
                        self.pt = PageTemplate()
                        self.pt.pt_edit(templateString, 'text/html')
                        self.pt.id = id
                        errors = self.pt.pt_errors()
                        if errors:
                                errorMsg = ''
                                for error in errors:
                                        errorMsg = errorMsg + error + '\n'
                                raise errorMsg
                        self.pt_cache[cacheKey] = self.pt
                        return 1

        def addToContext(self, context):
                self.context.update(context)

        def addPageTemplateToContext(self, id, templateFileName):
                rpt = renderPageTemplate()
                rpt.setTemplateFromFile(templateFileName, id)
                self.context[id] = rpt.pt

        def addXMLObjectToContext(self, XMLSchemaFileName, MixinClassDict):
                cachedXMLObject = cached_XML_Objectify(XMLSchemaFileName)
                schema = cachedXMLObject.make_instance()
                for elementName, element in schema.__dict__.items():
                        if MixinClassDict.has_key(elementName):
                                if type(element) == type([]):
                                        for instance in element:
                                               theClass = MixinClassDict[elementName]
                                               if theClass:
                                                       addBaseClass(instance, theClass) 
                                else:
                                       theClass = MixinClassDict[elementName]
                                       if theClass:
                                               addBaseClass(element, theClass)
                self.addToContext(schema.__dict__)
                return cachedXMLObject
                
        def renderToFile(self, outputFileName):
                of = open(outputFileName, "w")
                outputData = self.render()
                of.write(outputData)

        def render(self):
                return self.pt.pt_render(extra_context=self.context)


class cached_XML_Objectify:        
        xml_cache = {}

        def __init__(self, fileName):
                self.cachedInstance = None
                if not self.xml_cache.has_key(fileName):
                       self.xml_cache[fileName] = XML_Objectify(fileName)
                self.xo = self.xml_cache[fileName]

        def make_instance(self):
                if not self.cachedInstance:
                        self.cachedInstance = self.xo.make_instance()
                return self.cachedInstance

        def wipe_instance(self, fileName):
                del self.xml_cache[fileName]

def addBaseClass(instance, aClass):
        if not isinstance(instance, aClass):
                instance.__class__.__bases__ = (aClass,)   